/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2009-2010 EBM WebSourcing - http://www.petalslink.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package org.ow2.petals.jsr181;

/**
 * The JBI Context will be used by annotated POJO classes to get access to the
 * message sender. Since the {@link JBIContextManager} uses {@link ThreadLocal} each
 * worker (thread) will have access to its own sender.
 * 
 * @author Christophe HAMERLING - EBM WebSourcing
 */
public class JBIContextManager {

	private static ThreadLocal<JBIContext> tl = new ThreadLocal<JBIContext>();

	private JBIContextManager() {
	}

	public static JBIContext getJBIContext() {
		return tl.get();
	}

	public static void setJBIContext(JBIContext ctx) {
		tl.set(ctx);
	}
}
